/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Seldom used routines (overlay 2).  Chat mode, and miscellaneous.       *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <mem.h>
#include <time.h>
#include <io.h>
#include <dos.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <process.h>
#include <errno.h>
#include "prog.h"
#include "alc.h"
#include "max.h"
#include "max_msg.h"
#include "dr.h"


#ifndef ORACLE

void pascal Toggle_Yell_Noise(void)
{
  int x;

  prm.noise_ok=(char)!prm.noise_ok;
  Lprintf(s(yell_toggle),prm.noise_ok ? on : off);

  /* Update it in the *.PRM file */

  if ((x=shopen(prmname,O_RDWR | O_BINARY)) != -1)
  {
    write(x,(char *)&prm,sizeof(struct m_pointers));
    close(x);
  }
}

void pascal Fake_Noise(void)
{
  char string[50];
  int x,y;

  if (mdm_attr > 15)
     Puts(GRAY);

  strcpy(string,s(line_noise));

  for (y=0;y < 6;y++)
  {
    for (x=0;x < strlen(string);x++)
      string[x] += ((char)time(NULL)) | 0x80;

    Puts(string);

    Delay((unsigned int)(string[x-1]*456L) % 60);
  }

  logit(s(log_dump));
  mdm_hangup();
}

int pascal move_file(char *fromfile,char *tofile)
{
  if (fexist(tofile))
    return -1;

  if (rename(fromfile,tofile))
  {
    #ifdef __TURBOC__
    if (errno==ENOTSAM)    /* not same device */
    #else
    if (errno==EXDEV)      /* not same device */
    #endif
    {
      if (copy_file(fromfile,tofile)==0)
      {
        unlink(fromfile);
        return 0;
      }
      else return -1;
    }
    else return -1;
  }

  return 0;
}



int pascal copy_file(char *fromfile,char *tofile)
{
  int file1,
      file2,
      copy_size;

  char *temp;
  unsigned rbytes;
  unsigned wbytes;
  union stamp_combo sc;

  for (copy_size=COPY_SIZE;
       (temp=malloc(copy_size+1))==NULL && copy_size >= 128;
       copy_size /= 2)
    ;

  if (temp==NULL || copy_size < 128)
    return -1;

  if ((file1=shopen(fromfile,O_RDONLY | O_BINARY))==-1)
  {
    free(temp);
    return -1;
  }

  if ((file2=sopen(tofile,O_WRONLY | O_CREAT | O_TRUNC | O_BINARY,SH_DENYWR,S_IREAD | S_IWRITE))==-1)
  {
    close(file1);
    free(temp);
    return -1;
  }

  do
  {
    rbytes=read(file1,temp,copy_size);
    wbytes=write(file2,temp,rbytes);
  } while (rbytes==copy_size && rbytes==wbytes);

  /* preserve date of file */
  if (rbytes==wbytes)
  {
    if (! get_fdt(file1,&sc))
      set_fdt(file2,&sc);
  }

  close(file2);
  close(file1);

  free(temp);
  return ((rbytes==wbytes) ? 0 : -1);
}


void pascal Lost_Carrier(void)  /* This is what we run if a user drops carrier */
{
  caller_online=FALSE;

  mdm_dump(DUMP_all);

  Lputs(CYAN "\n");
  logit(s(log_byebye));
  quit(0);
}


/* Used when caller falls asleep */

void pascal PleaseRespond(void)
{
  if (!shutup)
    Puts(s(pls_rsp));

  vbuf_flush();
}



void pascal Time5Left(void) /* Only 5 min. left */
{
  if (!sent_time_5left && !shutup)
  {
    sent_time_5left=TRUE;
    do_timecheck=FALSE;
    Puts(s(min5_left));
    do_timecheck=TRUE;
    vbuf_flush();
  }
}



void pascal TimeAlmostUp(void)  /* Time limit almost used up (2 mins) */
{
  if (!sent_time_almostup && !shutup)
  {
    sent_time_almostup=TRUE;
    do_timecheck=FALSE;
    Puts(s(almost_up));
    do_timecheck=TRUE;
    vbuf_flush();
  }
}


void pascal TimeLimit(void)   /* User overrran time limit! */
{
  logit(s(log_tlimit));

  do_timecheck=FALSE;

  if (!shutup)
    Puts(s(time_up));

  vbuf_flush();
  mdm_hangup();
}


void pascal ChatMode(void)
{
  struct _stamp stamp;
  time_t ct;

  char temp[PATHLEN],
       lastword[BUFLEN],
       lastidx,
       last_speaker,
       break_loop,
       savekb,
       savesnoop,
       savedotc,
       ch,
       tl,
       col,
       x,y,
       p1[50],
       p2[50];

  int c;

  long startchat;

  if (*PRM(chat_prog))        /* If we have a specific prog. to run for CHAT */
  {
    startchat=time(NULL);

    Outside(NULL,NULL,OUTSIDE_dos,PRM(chat_prog),FALSE,CTL_none,
            RESTART_menu,NULL);

    /* Compensate for time spent in chat */
    Add_To_Time(min(time(NULL)-startchat,(timestart+(max_time*60L))-time(NULL)));

    return;
  }

  Draw_StatusLine(STATUS_force); /* Redraw to remove flashing 'C' */

  mdm_dump(DUMP_all);

  if (inchat)
  {
    Lputs(s(chat_nest));
    return;
  }

  savekb=keyboard;
  savesnoop=snoop;
  savedotc=do_timecheck;
  
  chatlog=NULL;
  keyboard=snoop=inchat=TRUE;
  do_timecheck=FALSE;

  logit(s(log_chat),entering,chatmode);

  startchat=time(NULL);

  *lastword='\0';
  lastidx=0;
  last_speaker=-1;

  if ((tl=topline) != FALSE)
    TopLine(LINE_restore);

  Lputs(s(chat_on));

  if (*PRM(chat_begin))
    Display_File(0,NULL,PRM(chat_begin));
  else Puts(s(chat_start));

  col=1;

  Mdm_Flow_Off();

  vbuf_flush();

  while (1)
  {
    /* Quick-add 3 minutes to user's time if it looks like s/he is going   *
     * under...  We'll do all of the other compensation at the end of      *
     * this module...                                                      */

    /* This is obsolete.  We now do everything at the end. */
    
    /*
    if (timeleft() <= 2 && time(NULL) < timeon+(max_time*60L))
    {
      timeoff += 180;
      startchat += 180;
    }
    */

    if (kbhit() || brk_trapped)
    {
      if (last_speaker != 0)
      {
        Puts(YELLOW);
        last_speaker=0;
      }

      break_loop=FALSE;

      if (brk_trapped)
      {
        brk_trapped=0;
        ch=3;
      }
      else ch=(char)pgetch();

      switch (ch)
      {
        case 0:             /* Scan code... */
          c=pgetch();

          if ((c >= 59 && c <= 68) || (c >= 84 && c <= 113))
            Parse_FKey(c);
          else if (c==36)  /* Alt-J */
          {
            Shell_To_Dos();
            Putc('\n');

            *lastword='\0';
            last_speaker=-1;
          }
          else if (graph != GRAPHICS_none)
          {
            switch (c)
            {
              case 72:        /* Up */
                if (current_line > 1)
                {
                  Puts(UP);
                  *lastword='\0';
                }
                break;

              case 75:        /* Left */
                if (current_col > 1)
                {
                  col--;
                  Puts(LEFT);
                  *lastword='\0';
                }
                break;

              case 77:        /* Right */
                if (current_col < usr.width)
                {
                  col++;
                  Puts(RIGHT);
                  *lastword='\0';
                }
                break;

              case 80:        /* Down */
                if (current_line < usr.len)
                {
                  Puts(DOWN);
                  *lastword='\0';
                }
                break;
            }
          }
          break;

        case 3:                 /* Chat buffer toggle */
          if (chatlog)          /* File is already open */
          {
            Lputs(s(chat_capoff));
            Close_Chatlog();
          }
          else                  /* File is closed, open buffer */
          {
            sprintf(temp,"%sCHATLOG.%03x",original_path,task_num);

            if (fexist(temp))
              chatlog=shfopen(temp,"r+",O_RDWR);
            else chatlog=shfopen(temp,"w+",O_RDWR | O_CREAT | O_TRUNC);

            if (temp==NULL)
              logit(cantopen,temp);
            else
            {
              Lputs(s(chat_capon));

              fseek(chatlog,0L,SEEK_END);

              TmDate_to_OpusDate(localtime(((ct=time(NULL)),&ct)),&stamp);

              strcpy(p1,Timestamp_Format(PRM(dateformat),&stamp,temp));
              strcpy(p2,Timestamp_Format(PRM(timeformat),&stamp,temp));

              fprintf(chatlog,s(chat_logmsg),p1,p2,usr.name);
            }
          }

          ch=0;
          break;

        case 7:
          Putc('\a');
          ch=0;
          break;

        case 27:                /* ESCape */
          break_loop=TRUE;
          break;
      }

      if (break_loop)
        break;
    }
    else if (mdm_avail())
    {
      if (last_speaker != 1)
      {
        Puts(CYAN);
        last_speaker=1;
      }

      switch (ch=(char)(mdm_ggetcw() & (usr.ibmchars ? 0xff : 0x7f)))
      {
        case 27:
          if (((ch=(char)mdm_ggetcw()) & 0x7f)=='[' || ch=='O')
          {
            switch (mdm_ggetcw() & 0x7f)  /* Strip all other ANSI sequences! */
            {
              case 'A':       /* Up */
                Puts(UP);
                *lastword='\0';
                break;

              case 'D':        /* Left */
                col--;
                Puts(LEFT);
                *lastword='\0';
                break;

              case 'C':        /* Right */
                col++;
                Puts(RIGHT);
                *lastword='\0';
                break;

              case 'B':        /* Down */
                Puts(DOWN);
                *lastword='\0';
                break;
            }
          }

          ch=0;
          break;
      }
    }
    else
    {
      ch=0;
      Giveaway_Slice();
    }

    switch (ch)
    {
      case '\x00':                /* If we didn't get anything... */
      case '\x07':                /* or we got a BEL...           */
      case '\x0a':                /* or we got a linefeed...      */
        break;                    /* then don't do anything!      */

      case 127:                   /* VT100 del */
      case '\x08':                /* Backspace */
        if (col > 1)
        {
          col--;
          Puts(bs_sp_bs);

          if (lastidx)
            lastword[--lastidx]='\0';

          if (chatlog)            /* Seek back one */
            fseek(chatlog,ftell(chatlog)-1L,SEEK_SET);
        }

        break;

      case '\x0d':                /* Carriage return */
        Putc('\n');
        lastword[lastidx=0]='\0';
        col=1;

        if (chatlog)
          fputc('\n',chatlog);
        
        break;

      case '\x09':                /* TAB */
        x=(char)(9-(current_col % 8));

        if (chatlog)
          for (y=0;y < x;y++)
            fputc(' ',chatlog);

        Printf("\x19 %c",x);

        lastword[lastidx=0]='\0';
        col += x;
        break;

      case '+':                   /* Guard against "+++" sequence */
        Puts("+\x08");
        /* fall-through */

      default:                    /* Normal character */
        if (chatlog)
          fputc(ch,chatlog);

        Putc(ch);
        col++;

        if (lastidx >= sizeof(lastword)-2)
          lastword[lastidx=0]='\0'; /* If word is too long, zero out */
        else
        {
          lastword[lastidx]=ch;     /* Add to last word buffer */
          lastword[++lastidx]='\0';
        }

        /* If it's a space, zero out lastword buffer */
        
        if (ch==' ' || ch==',' || ch=='-')  
          lastword[lastidx=0]='\0';

        if (col >= usr.width-4)             /* Time to wordwrap! */
        {
          if (strlen(lastword) > usr.width/2)
          {
            if (chatlog)
              fputc('\n',chatlog);

            Puts(CLEOL "\n");
            lastword[lastidx=0]='\0';
            col=1;
          }
          else
          {
            for (x=0;(int)x < strlen(lastword);x++)  /* Back up over word */
            {
              if (graph==GRAPHICS_none)
                Puts(bs_sp_bs);
              else Putc('\x08');    /* We'll erase later with CLEOL */
            }

            Puts(CLEOL "\n");                 /* New line... */
            Puts(lastword);                   /* Drop the word in place */

            if (chatlog)                      /* Back up that many spaces... */
            {
              fseek(chatlog,-(long)x,SEEK_CUR);

              if (chatlog)
                fputc('\n',chatlog);

              fputs(lastword,chatlog);
            }

            col=(char)(strlen(lastword)+1);       /* Set new column counter */
          }
        }
        break;
    }

    if (ch != 0)
      vbuf_flush();
  }

  Mdm_Flow_On();

  if (chatlog)
    Close_Chatlog();

  logit(s(log_chat),exiting,chatmode);

  /* Time compensation */

  if (time(NULL) < timestart+(max_time*60L))
    Add_To_Time(min(time(NULL)-startchat,(timestart+(max_time*60L))-time(NULL)));
  
  /* Even if it would override an event, give the sucker 60 seconds after  *
   * exiting chat, so they don't go <poof> as soon as the SysOp hits <esc> *
   * to exit chat.  (Sometimes, that may happen accidentally.              */
  
  if (timeoff < time(NULL)+60L)
    timeoff=time(NULL)+60L;

  do_timecheck=savedotc;

  display_line=display_col=1; /* So "More [Y,n,=]?" doesn't happen right   *
                               * after CHAT finishes.                      */
  keyboard=savekb;
  snoop=savesnoop;
  inchat=FALSE;

  if (*PRM(chat_end))
    Display_File(0,NULL,PRM(chat_end));
  else Puts(s(chat_end));

  if (tl)
    TopLine(LINE_top);

  Puts(press_enter);

  if (inmagnet)
    Fix_MagnEt();
}


void pascal Parse_FKey(int c)
{
  Display_File(0,NULL,"%s%sF%d",PRM(misc_path),
               (c >=  59 && c <=  68) ? blank_str :
               ((c >=  84 && c <=  93) ? "S" :
               ((c >=  94 && c <= 103) ? "C" :
               ((c >= 104 && c <= 113) ? "A" :
               blank_str))),
               (c >=  59 && c <=  68) ? c-58 :
               ((c >=  84 && c <=  93) ? c-83 :
               ((c >=  94 && c <= 103) ? c-93 :
               ((c >= 104 && c <= 113) ? c-103 :
               1))));

  if (inmagnet)
    Fix_MagnEt();

  input_timeout=timerset(TIMEOUT*100);
}

#endif    /* !ORACLE */

